#ifndef ARRAY_BENCHMARK_HPP
#define ARRAY_BENCHMARK_HPP


class array_benchmark
{
public:
    array_benchmark (const char * outfile_name)
        : _outfile_name(outfile_name)
        {
        }

    virtual ~array_benchmark ()
        {
        }
    
    virtual void setup (const unsigned length) = 0;
    virtual void run () = 0;
    virtual void teardown () = 0;
    virtual const char * get_name () const = 0;

    const char * get_outfile_name () const
        {
            return _outfile_name;
        }

private:
    const char * _outfile_name;
};


#endif
