#ifndef MATRIX_BENCHMARK_HPP
#define MATRIX_BENCHMARK_HPP


class matrix_benchmark
{
public:
    matrix_benchmark (const char * outfile_name)
        : _outfile_name(outfile_name)
        {
        }

    virtual ~matrix_benchmark ()
        {
        }
    
    virtual void setup (const unsigned rows, const unsigned cols) = 0;
    virtual void run () = 0;
    virtual void teardown () = 0;
    virtual const char * get_name () const = 0;

    const char * get_outfile_name () const
        {
            return _outfile_name;
        }

private:
    const char * _outfile_name;
};


#endif
