#ifndef UTILITY_FUNCTIONS_HPP
#define UTILITY_FUNCTIONS_HPP

#include "host_and_device.hpp"

HOST_AND_DEVICE
inline
float
cast_to_float(int i)
{
  return static_cast<float>(i);
}

HOST_AND_DEVICE
inline
int
int_abs(int i)
{
  return i < 0 ? -i : i;
}

HOST_AND_DEVICE
inline
int
int_negate(int i)
{
    return -i;
}

HOST_AND_DEVICE
inline
float
float_negate(float i)
{
    return -i;
}

#endif
